unit ForParse;
{*********************************************}
{                                             }
{   Chemical Formula Parser                   }
{                                             }
{   (C) 2002 Belov G.V.,                      }
{       OIVT RAN, Glushko Thermocenter        }
{                                             }
{   Please send bugs, comments and            }
{   suggestions to:                           }
{                                             }
{   gbelov@imail.ru                           }
{                                             }
{   status: FREE                              }
{                                             }
{*********************************************}

interface
const MaxNumberOfElements = 5; // max number of elements in chemical formula

Type TNos = ShortInt;
     TQty = double;
     TEL_Nos = array[1..MaxNumberOfElements] of TNos;
     TEL_Qty = array[1..MaxNumberOfElements] of TQty;
     
procedure PaF(in_st: string; var EL_NO: TEL_NOS; var EL_QTY: TEL_QTY;
                       var NumOfElts: ShortInt; var PhStateCode: byte;
                       var IonCharge: ShortInt; var Error: string);
procedure ParseFormula(in_st: string; var EL_NO: TEL_NOS; var EL_QTY: TEL_QTY;
                       var NumOfElts: ShortInt; var Error: string);
implementation
uses AtConst,SysUtils,Dialogs;
function CheckElement(var CurrEltNo: integer; var st_fml: string;
                      var EL_NO: TEL_NOS; var NumOfElts: ShortInt): string;
var j: integer;
begin
  Result := '';
  if st_fml > ' ' then
  for j := 1 to NumOfElts do
    if AtomicData[EL_NO[j]].Formula = st_fml then
      begin CurrEltNo := j; Exit; end;
  for j := Low(AtomicData) to High(AtomicData) do
     if st_fml = AtomicData[j].Formula then
       begin
       st_fml := '';
       inc(NumOfElts);
       CurrEltNo := NumOfElts;
       EL_NO[NumOfElts] := j;
       Exit;
       end;
//  if not found then
  Result := 'Unknown element: '+st_fml;
end;

function FmlStringToFloat(var st : string): double;
var Code,i : integer;
    ST_RES : string;
begin
  ST_RES := st;
  i := Length(St_RES);
  while (Length(ST_RES) > 0) and (ST_RES[i] <= ' ') do
    begin
    Delete(ST_RES,i,1);
    Dec(i);
    end;
  repeat
  i := Pos(',',ST_RES);
  if i > 0 then ST_RES[i] := '.' else Break;
  until i > 0;
  System.Val(ST_RES,Result,Code);
  if Code = 0 then st := ''
  else st := 'Invalid number: '+st;
end;

procedure ParseFormula(in_st: string; var EL_NO: TEL_NOS; var EL_QTY: TEL_QTY;
                       var NumOfElts: ShortInt; var Error: string);
Label 1,2;
var i,CurrEltNo,i1,j1: integer;
    D: double;
    st,st_fml, st_num: string;
    found: boolean;
    LocEL_NO: TEL_NOS;
    LocEL_QTY: TEL_QTY;
    LocNumOfElts: ShortInt;
begin
  Error := '';
// check parenthesis
  i1 := 0;
  for i := 1 to Length(in_st) do
    if in_st[i] = '(' then inc(i1)
    else if in_st[i] = ')' then dec(i1);
  if i1 <> 0 then
    begin
    Error := 'Invalid formula: '+in_st;
    Exit;
    end;
  NumOfElts := 0;
  CurrEltNo := 0;
  for i := 1 to MaxNumberOfElements do
    begin
    EL_NO[i] := 0;
    EL_QTY[i] := 0;
    end;
// test if electrone
  if in_st = 'e' then Exit;
  st_fml := '';
  st_num := '';
  i := 0;
  while i < Length(in_st) do
    begin
    inc(i);
    if in_st[i] in ['0'..'9','.'] then
// if number
      begin
      st_num := st_num + in_st[i];
      if st_fml > ' ' then
        begin
        Error := CheckElement(CurrEltNo,st_fml, EL_NO, NumOfElts);
        if Error > ' ' then Exit;
        end;
      end
    else if in_st[i] in ['a'..'z','A'..'Z'] then
// if formula
      begin
      if Length(st_fml) > 0 then
        if in_st[i] in ['A'..'Z'] then
          begin
          Error := CheckElement(CurrEltNo, st_fml, EL_NO, NumOfElts);
          if Error > ' ' then Exit;
          if st_num < ' ' then
            EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + 1;
          st_fml := '';
          end;
      st_fml := st_fml + in_st[i];
      if st_num > ' ' then
        begin
        D := FmlStringToFloat(st_num);
        if st_num > ' ' then
          begin
          Error := st_num;
          Exit;
          end;
        EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + D;
        end;
      end
    else if in_st[i] = '(' then
// group
      begin
      if st_fml > ' ' then
        begin
        Error := CheckElement(CurrEltNo,st_fml, EL_NO, NumOfElts);
        if st_num < ' ' then
          EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + 1;
        if Error > ' ' then Exit;
        end;
        if st_num > ' ' then
          begin
          D := FmlStringToFloat(st_num);
          if st_num > ' ' then
            begin
            Error := st_num;
            Exit;
            end;
          EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + D;
          end;
      st := '';
      inc(i);
      i1 := 1;
      while (i < Length(in_st)) and (i1 <> 0) do
        begin
        if in_st[i] = ')' then dec(i1)
        else if in_st[i] = '(' then inc(i1);
        if i1 <> 0 then st := st + in_st[i];
        inc(i);
        end;
      if in_st[i] in ['A'..'Z','a'..'z','('] then Dec(i);
      if st < ' ' then
        begin
        Error := 'Invalid formula: '+in_st;
        Exit;
        end;
      ParseFormula(st, LocEL_NO, LocEL_QTY, LocNumOfElts, Error);
      if Error > ' ' then Exit;
      if (i <= Length(in_st)) and (in_st[i] in ['0'..'9','.']) then
// compute group multiplier
        begin
        st := '';
        while (i <= Length(in_st)) and (in_st[i] in ['0'..'9','.']) do
          begin
          st := st + in_st[i];
          inc(i);
          end;
        if (i > Length(in_st)) or (in_st[i] in ['A'..'Z','a'..'z','(']) then Dec(i);
        if st > ' ' then
          begin
          D := FmlStringToFloat(st);
          if st > ' ' then
            begin
            Error := st;
            Exit;
            end;
          for i1 := 1 to LocNumOfElts do
            LocEL_QTY[i1] := LocEL_QTY[i1] * D;
          end;
        end;  // end compute group multiplier
      if NumOfElts = 0 then
        begin
        NumOfElts := LocNumOfElts;
        EL_NO := LocEL_NO;
        EL_QTY := LocEL_QTY;
        end
      else
        for i1 := 1 to LocNumOfElts do
          begin
          found := False;
          for j1 := 1 to NumOfElts do
            if EL_NO[j1] = LocEL_No[i1] then
              begin
              EL_QTY[j1] := EL_QTY[j1] + LocEL_QTY[i1];
              found := True;
              Break;
              end;
          if not found then
            begin
            inc(NumOfElts);
            EL_NO[NumOfElts] := LocEL_NO[i1];
            EL_QTY[NumOfElts] := LocEL_QTY[i1];
            end;
          end;
      end;
    end;  // end while i < Length(in_st)

    if st_fml > ' ' then
      begin
      Error := CheckElement(CurrEltNo,st_fml, EL_NO, NumOfElts);
      if Error > ' ' then Exit;
      if st_num < ' ' then
        EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + 1;
      end;
      if st_num > ' ' then
        begin
        D := FmlStringToFloat(st_num);
        if st_num > ' ' then
          begin
          Error := st_num;
          Exit;
          end;
        if CurrEltNo = 0 then
          begin
          Error := 'Invalid formula: '+in_st;
          Exit;
          end;
        EL_QTY[CurrEltNo] := EL_QTY[CurrEltNo] + D;
        end;
end;

procedure PaF(in_st: string; var EL_NO: TEL_NOS; var EL_QTY: TEL_QTY;
                       var NumOfElts: ShortInt; var PhStateCode: byte;
                       var IonCharge: ShortInt; var Error: string);
const PSS: array[1..8] of string = ('(g)','(g;','(+','(-','(c','(l','(am','(gl');
var i,j: integer;
    st: string;
begin
// remove spaces
  st := '';
  for i := 1 to Length(in_st) do
    if in_st[i] > ' ' then st := st + in_st[i];
  in_st := st;
  if in_st < ' ' then
    begin
    Error := 'Formula is not specified';
    Exit;
    end;
  PhStateCode := 0;
  IonCharge := 0;
// get pstate code
  for j := 1 to High(PSS) do
    begin
    i := Pos(PSS[j],in_st);
    if i > 0 then
      begin
      st := System.Copy(in_st,i+1,100);
      System.Delete(in_st,i,100);
      case j of
      1,2: PhStateCode := 2;
      3,4: begin
           PhStateCode := 2;
           if j = 3 then IonCharge := 1
           else if j = 4 then IonCharge := -1;
           i := 1;
           if (Length(st) - i) >= 1 then
             begin
             while (i < Length(st)) and (st[i] in ['+','-','0'..'9']) do
               begin
               inc(i);
               end;
             Dec(i);
             SetLength(st,i);
             if Length(st) > 1 then
try
             IonCharge := StrToInt(st);
except
             Error := 'Invalid ion charge: '+st;
             Exit;
end;
             end;
           end;
      5..8: PhStateCode := 1;
      end;
      Break;
      end;
    end;
  ParseFormula(in_st, EL_NO, EL_QTY, NumOfElts, Error);
end;

end.
